#include "\4270\DMM0.h"
#include "msp430x42x0.h"
#include <math.h>
#include <stdlib.h>


void MEA_Temp(void);

const float AR = 3.9083e-3;               // Pt-RTDAW
const float BR = -5.775e-7;               // Pt-RTDBW
const float R0 = 100.;                    // Pt-RTD̊R
float Tset = 60.;                         // ݒ艷x(80܂)
const float KI = .5;                      // x̔W
const float KP = 100.;                    // x̐ϕ萔

// ʕϐ(DMM0.hexternŒ`)
  int LEDFG;                              // LED_ŗp, Yrbg1ɂƓ_
                                          //  = 1,  = 2, 1 = 4, 2 = 8
  int Disp_Dat;                           // LCD\pϐ
  int Sel_Num;                            // 胂[h̔ԍpϐ
  int SELFG;                              // 胂[hptO
  unsigned short TAR_period;              // pTARi[ϐ
  unsigned short Cnt_OVF;                 // TARI[ot[̌vpϐ
  unsigned short Num_OVF;                 // TARI[ot[̉
  long cnt0;

void main(void)
{
  WDTCTL = WDTPW + WDTHOLD;               // WDT̒~@ccc@
  SCFQCTL = 94 - 1;                       // MCLK = 94 * ACLK * 2 = 6.16MHz, D = 2@cccA
  FLL_CTL0 = DCOPLUS + XCAP18PF;          // DCOPLUS = 1, eʕׂ18pF@cccB
  SCFI0 = FLLD_2 + FN_2;                  // D = 2, fDCOCLK =   2.2-17Mhz@cccC

  init_DMM();                             // DMM@\̏
  init_LCD();                             // LCD\@\̏

  BTCTL = BT_ADLY_2000;                   // Basic Timer̃NbNACLK/256
  t1ms(5);                                // 5ms҂. FLL+肷̂҂
  P5DIR |= 0x10;

  DAC12_0CTL = DAC12OPS + DAC12SREF_0 + DAC12LSEL_0 + DAC12AMP_7 + DAC12IR; //@cccD
      // DACo͂O[qɏo, dAVcc, DAC12_0DATނƑDACo
      // DACo͂̍ől͊d, Av͍(d)[h

  DAC12_0DAT = 4095;                      // DAf[^DAC12ɐݒ@cccJ

  _BIS_SR(GIE);                           // Ӽޭي݋

  do
  {
    MEA_Temp();                           // x䃋[`ɓ(߂ĂȂ̂Œ)
  }while(1);                              // ivɌJԂ
}

void MEA_Temp(void)
{
  float V0, V1, V7;                       // ADϊd
  float R;                                // ߂Rl
  float T;                                // ߂Rl
  long AD_Sum;                            // ADϊf[^̐ώZpϐ
  int i, j;                               // forȂǂ̕ϐp
  int Po;                                 // forȂǂ̕ϐp
  float IR;

// SD16Ȁݒ
  SD16CTL = SD16VMIDON + SD16REFON + SD16SSEL_1 + SD16DIV_3 + SD16XDIV_2;  // 1.2V ref, SMCLK, /8, /16
  t1ms(1);                                // 1ms҂
  SD16CTL &= ~SD16VMIDON;                 // VMID off: used to settle ref cap
  SD16CTL = SD16REFON + SD16SSEL_1 + SD16DIV_3 + SD16XDIV_2;  // 1.2V ref, SMCLK, /8, /3, fM = 44kHz
  SD16CCTL0 =  SD16UNI + SD16OSR_1024 + SD16BUF_0; // j|[, OSR = 1024, obt@It
  IR = 0;
  do
  {
    P6OUT &= ~0x40;                       // P6.6 = 0, d𗬂
    j = (j + 1) & 0x3;                    // j = 0̎Af[^VAʐMőM

// ͒Z̑
    SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_8 + SD16INCH_7; // ͒Z̐ݒ
    SD16CCTL0 |= SD16SC;                  // ADϊJn
    AD_Sum = 0;                           // AD_SumNA
    for (i = 0; i < 8; i++)
    {
      while ((SD16CCTL0 & SD16IFG) == 0); // ϊI҂
      AD_Sum = AD_Sum + SD16MEM0;         // ADϊlώZ
    }
    SD16CCTL0 &= ~SD16SC;                 // ADϊ~
    V7 = AD_Sum / 8. / 65535. * Vref2/8.;    // V7߂

// V1̑
    SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_8 + SD16INCH_1; // CH = 1(Vx̑)
    SD16CCTL0 |= SD16SC;                  // ADϊJn
    AD_Sum = 0;                           // AD_SumNA
    for (i = 0; i < 8; i++)
    {
      while ((SD16CCTL0 & SD16IFG) == 0); // ϊI҂
      AD_Sum = AD_Sum + SD16MEM0;         // ADϊlώZ
    }
    SD16CCTL0 &= ~SD16SC;                 // ADϊ~
    V1 = AD_Sum / 8. / 65535. * Vref2/8.;    // V1߂


// V0̑
    SD16INCTL0 = SD16INTDLY_0 + SD16GAIN_8 + SD16INCH_0; // CH = 0(Ix̑)
    SD16CCTL0 |= SD16SC;                  // ADϊJn
    AD_Sum = 0;                           // AD_SumNA
    for (i = 0; i < 8; i++)
    {
      while ((SD16CCTL0 & SD16IFG) == 0); // ϊI҂
      AD_Sum = AD_Sum + SD16MEM0;         // ADϊlώZ
    }
    SD16CCTL0 &= ~SD16SC;                 // ADϊ~
    V0 = AD_Sum / 8. / 65535. * Vref2/8.;    // V0߂

// v[udIt
    P6OUT |= 0x40;                        // P6.6 = 1, dIt

// ŘvZ
    R = (V0 - V7) / (V1 - V7) * 100.;     // Rx߂
//    R = V0 / V1 * 100.;      // Rx߂
    T = (-AR + sqrt(pow(AR,2)-4*BR*(1-R/100)))/2/BR; // x߂
    if (abs(Tset - T)/Tset > .2)          // x΍߂
    {
      IR = 0;                             // }20%ȏ㍷ꍇAϕʂNA
    }
    else
    {
      IR = IR+(Tset - T);                 // x΍̐ϕ
    }
    Po = KP * (Tset - T) + KI * IR + 2000;  // o̓p[̌vZ
    if (Po > 4095) Po = 4095;             // 4095ȏȂ4095
    if (Po < 2000) Po = 2000;             // 2000ȉȂ2000B2000̓gWX^̃oCAXd
    if (T<-20) Po = 0;                    // x20ȉ̓ZTُ
    DAC12_0DAT = Po;

    // Rl̕\
    disp(T * 100);                        // ŏ\Pʂ.01

    if ( j == 0)
    {
      T = T *100;                         // xf[^VAʐMŏo
      TX_DAT((int)T>>8);
      TX_DAT((int)T);
    }
  } while(1); // [v
}
